﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
' Class module CustomGauge
' Enhanced version based upon the ABMaterial Demo CustomGauge by Alain Bailleul
' References:
' http://www.justgage.com
' https://github.com/toorshia/justgage
' Checkout more settings at https://github.com/toorshia/justgage
' Author Alain Bailleul, Robert W.B. Linn @rwblinn.de
' Version 20171129
'
' TODO:
' Set min / max scale dynamicalls
'
' USAGE:
' Sub Class_Globals
'    Dim custGauge As CustomGauge
'
' Sub BuildPage()
'   page.AddExtraJavaScriptFile("custom/justgage.js") 
'	page.AddExtraJavaScriptFile("custom/raphael-2.1.4.min.js")
'
' Sub ConnectPage()
'   custGauge.Initialize(page, "custGauge", 25, "Test")
'   page.Cell(7,1).AddComponent(custGauge.ABMComp)
'	
'   Dim custGaugebtn1 As ABMButton
'   custGaugebtn1.InitializeRaised(page, "custGaugebtn1", "", "", "BUTTON", "")
'	page.Cell(7,1).AddComponent(custGaugebtn1)
'
'Sub custGaugebtn1_Clicked(Target As String)
'	custGauge.myValue = Rnd(10,100)
'	custGauge.ABMComp.Refresh
'End Sub

Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	' GaugeValue is public because used by the WeatherPage to update the value after sample timer tick (in module tfshared).
	Public GaugeValue As Double
	' All properties must be set in the map. 
	Private mProperties As Map
End Sub

'Initializes the object. 
'Example <code>
'	Dim properties As Map = CreateMap("title":"Humidity", "label":"%RH", "value":Humidity, "min":53, "max":55, "decimals":2, "gaugecolor":"#0000FF")
'</code>
Public Sub Initialize(InternalPage As ABMPage, ID As String, Properties As Map)
    ABMComp.Initialize("ABMComp", Me, InternalPage, ID, "")
	mProperties = Properties
	GaugeValue = mProperties.Get("value")
End Sub

Sub ABMComp_Build(InternalPage As ABMPage, internalID As String) As String
	Dim html As String = $"<div id="${internalID}" style="width:100px; height:80px"></div>
						   <script>var _${internalID};</script>
						 "$
	Return html
End Sub

' Is useful to run some initalisation script.
' IMPORTANT: Check all properties are lowercase. When copy paste in the B4J IDE properties change i.e. min = Min, max = Max, if = If, true = True ...
' Checkout more settings ate https://github.com/toorshia/justgage
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim script As String = $"_${internalID} = new JustGage({
								id: "${internalID}",
                             	// title: "${mProperties.Get("title")}", has been removed according documentation
								label: "${mProperties.Get("label")}",
                             	value: ${GaugeValue},
                             	min: ${mProperties.Get("min")},
                             	max: ${mProperties.Get("max")},
                             	relativeGaugeSize: true,
								pointer: true,
								gaugeColor: "${mProperties.Get("gaugecolor")}",
					            decimals: ${mProperties.Get("decimals")}
                           		});
						   "$
     InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
    ' flush not needed, it's done in the refresh method in the lib
End Sub

' Runs when a refresh is called
' IMPORTANT: Check all properties are lowercase. When copy paste in the B4J IDE properties change i.e. min = Min, max = Max, if = If ...
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' Important as the gauge is showing its value after refresh
	Dim script As String = $"//Refresh the Gauge
							_${internalID}.refresh(${GaugeValue});
						   "$
	' Example changing the max range of the gauge
	' Dim GaugeMax As Int = Round(GaugeValue) * 1.1
	' Dim script As String = $"_${internalID}.refresh(${GaugeValue}, ${GaugeMax});"$
	InternalPage.ws.Eval(script, Null)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
' NO ACTION	
End Sub

