﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
' Class module WeatherDashboardPage
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "WeatherDashboardPage"  '<-------------------------------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""
	' your own variables
	' Helpers with inital values
	Private myToastId As Int	'ignore
	' Define the weather components
	' Humidity
	Private Humidity As Double = 0
	Private customGaugeHumidity As CustomGauge
	Dim LineChartHumidity As CustomLineChart
	' Temperature
	Private Temperature As Double = 0
	Private customGaugeTemperature As CustomGauge
	Dim LineChartTemperature As CustomLineChart
	' AirPressure
	Private AirPressure As Double = 0
	Private customGaugeAirPressure As CustomGauge
	Dim LineChartAirPressure As CustomLineChart
	' ADD MORE SENSORS
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage		
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)	
	Log("Connected")
		
	ws = WebSocket1		
	
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	'----------------------START MODIFICATION 4.00-------------------------------
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	'----------------------END MODIFICATION 4.00-------------------------------
	
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If		
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)		
	If page.ComesFromPageCache Then
    	' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		Log("Comes from cache")		
    	page.Refresh		
    	page.FinishedLoading		
	Else
    	If page.WebsocketReconnected Then
			Log("Websocket reconnected")
        	' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have any on the server. So we need to reload the page.
        	' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has content, reconnected but we have no content in cache
        	ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
    	Else
        	' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
        	Log("Websocket first connection")
			page.Prepare
			ConnectPage			
    	End If
	End If

	Main.ConnectedBrowsers.Put(Me, "")

	Log(ABMPageId)		
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
	Main.ConnectedBrowsers.Remove(Me)
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	Dim caller As Object = page.GetEventHandler(Me, eventName)
	If caller = Me Then
		If SubExists(Me, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			' BEGIN NEW DRAGDROP
			If eventName = "page_dropped" Then
				page.ProcessDroppedEvent(Params)
			End If
			' END NEW DRAGDROP
			Select Case Params.Size
				Case 0
					CallSub(Me, eventName)
				Case 1
					CallSub2(Me, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Me, eventName, PassedTables)
					Else
						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Me, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)

	theme.AddInputTheme("inputauto")
	theme.Input("inputauto").AutoCompleteZDepth = ABM.ZDEPTH_1

	' add additional themes specific for this page
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Weather Dashboard "
	page.PageDescription = "Weather dashboard prototype using TinkerForge bricklets Humidity, Temperature, Barometer"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
				
	' adding a navigation bar
	ABMShared.BuildNavigationBar(page, "Weather Dashboard","", "", "", "")
			
	' create the page grid
	' EXAMPLE page.AddRowsM(5,True,0,0, "").AddCells12MP(1,0,0,0,0,"")

	' R1 1x4 + 1x4 + 1x4 = [Gauge Humidity][Gauge Temperature][Gauge AirPressure]
	page.AddRows(1,True,"").AddCellsOS(1,0,0,0,4,4,4,"").AddCellsOS(1,0,0,0,4,4,4,"").AddCellsOS(1,0,0,0,4,4,4,"")
	' R2 1x4 + 1x4 + 1x4 = [Chart Humidity][Chart Temperature][Chart AirPressure]
	page.AddRows(1,True,"").AddCellsOS(1,0,0,0,4,4,4,"").AddCellsOS(1,0,0,0,4,4,4,"").AddCellsOS(1,0,0,0,4,4,4,"")

	' IMPORTANT to load the complete grid AND before you start adding components
	page.BuildGrid

	' Add the extra JS & CSS files
	' Gauge
	page.AddExtraJavaScriptFile("custom/justgage.js")
	page.AddExtraJavaScriptFile("custom/raphael-2.1.4.min.js")
	' LineChart
	page.AddExtraJavaScriptFile("custom/chart.min.js")
	
	' Add more like BuildFooter
	ABMShared.BuildFooter(page)
End Sub

public Sub ConnectPage()
	' Connect the navigation bar
	ABMShared.ConnectNavigationBar(page)

	' Add modal sheets

	' Add the components
	' Weather data are for each bricklet, displayed in a Gauge + LineChart. These use a single property map. All keys must be lowercase.
	Dim HumidityProperties As Map = CreateMap("title":"Humidity", "label":"%RH", "value":Humidity, "min":DataSampler.Settings.Get("humiditymin"), "max":DataSampler.Settings.Get("humiditymax"), "decimals":2, "gaugecolor":"#edebeb", "maxsamples":DataSampler.Settings.Get("maxsamples"))
	Dim TemperatureProperties As Map = CreateMap("title":"Temperature", "label":"°C", "value":Temperature, "min":DataSampler.Settings.Get("temperaturemin"), "max":DataSampler.Settings.Get("temperaturemax"), "decimals":2, "gaugecolor":"#edebeb", "maxsamples":DataSampler.Settings.Get("maxsamples"))
	Dim AirPressureProperties As Map = CreateMap("title":"AirPressure", "label":"mbar", "value":AirPressure, "min":DataSampler.Settings.Get("airpressuremin"), "max":DataSampler.Settings.Get("airpressuremax"), "decimals":2, "gaugecolor":"#edebeb", "maxsamples":DataSampler.Settings.Get("maxsamples"))
	' R1
	Dim Row As Int = 1
'	Private customGaugeHumidity As CustomGauge
	customGaugeHumidity.Initialize(page, "custGaugeHumidity", HumidityProperties)
	page.Cell(Row,1).AddComponent(customGaugeHumidity.ABMComp)
'	Private customGaugeTemperature As CustomGauge
	customGaugeTemperature.Initialize(page, "custGaugeTemperature", TemperatureProperties)
	page.Cell(Row,2).AddComponent(customGaugeTemperature.ABMComp)
'	Private customGaugeAirPressure As CustomGauge
	customGaugeAirPressure.Initialize(page, "custGaugeAirPressure", AirPressureProperties)
	page.Cell(Row,3).AddComponent(customGaugeAirPressure.ABMComp)

	' R2
	Row = 2
	LineChartHumidity.Initialize(page, "LineChartHumidity", HumidityProperties)
	page.Cell(Row,1).AddComponent(LineChartHumidity.ABMComp)
	page.Cell(Row,1).PaddingLeft = "10"
	page.Cell(Row,1).PaddingRight = "10"

	LineChartTemperature.Initialize(page, "LineChartTemperature", TemperatureProperties)
	page.Cell(Row,2).AddComponent(LineChartTemperature.ABMComp)
	page.Cell(Row,2).PaddingLeft = "10"
	page.Cell(Row,2).PaddingRight = "10"
   
	LineChartAirPressure.Initialize(page, "LineChartAirPressure", AirPressureProperties)
	page.Cell(Row,3).AddComponent(LineChartAirPressure.ABMComp)
	page.Cell(Row,3).PaddingLeft = "10"
	page.Cell(Row,3).PaddingRight = "10"

	' Update the footer
	ABMShared.labelSampleStatus.Text = DataSampler.SampleLogMessage

	' refresh the page
	page.Refresh
	
	' Tell the browser we finished loading
	page.FinishedLoading

	' restoring the navigation bar position
	page.RestoreNavigationBarPosition

End Sub

Sub page_MsgboxResult(returnName As String, result As String)
	
End Sub

Sub Page_Dropped(Params As Map)
	If Params.Get("before") = "" Then
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target"))
	Else
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target") & " before component " & Params.Get("before"))
	End If	
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "About" Then
		' MessageBox
		page.Msgbox("MSGBOXABOUT", _ 
					$"${Main.APPVERSION}{BR}(c) 2017 by Robert W.B. Linn @{AL}http://www.rwblinn.de{AT}rwblinn.de{/AL}{BR}{BR}"$ & _ 
					$"Development Tool: {AL}http://www.b4x.com/b4j.html{AT}B4J{/AL}{BR}Framework: {AL}https://alwaysbusycorner.com/abmaterial/{AT}ABMaterial{/AL}{BR}Devices: {AL}http://www.tinkeforge.com{AT}TinkerForge{/AL}"$, _ 
					"About", "OK", True, ABM.MSGBOX_POS_CENTER_CENTER, "bluegrey")
		Return
	End If
'	NOT USED
'	If Action = "LogOff" Then
'		ABMShared.LogOff(page)
'		Return
'	End If

	ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub

Sub Page_InputboxResult(returnName As String, result As String)
	
End Sub

Sub Page_DebugConsole(message As String)
	Log("---> " & message)
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)
	
End Sub

Sub Page_ToastClicked(toastID As String, Action As String)
		
End Sub

Sub Page_ToastDismissed(ToastId As String)
	
End Sub

Sub Page_Authenticated(Params As Map)
	
End Sub

Sub Page_FirebaseAuthError(extra As String)
	
End Sub

Sub Page_FirebaseAuthStateChanged(IsLoggedIn As Boolean)
	
End Sub

Sub Page_FirebaseStorageError(jobID As String, extra As String)
	
End Sub

Sub Page_FirebaseStorageResult(jobID As String, extra As String)
	
End Sub

Sub Page_ModalSheetDismissed(ModalSheetName As String)
	
End Sub

Sub Page_NextContent(TriggerComponent As String)
	
End Sub

Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
	
End Sub

Sub page_CellClicked(Target As String, RowCell As String)
	
End Sub

Sub page_RowClicked(Target As String, Row As String)
	
End Sub

Sub Page_NativeResponse(jsonMessage As String)
	
End Sub

Sub Page_NavigationbarSearch(search As String)
	
End Sub

#Region UpdatePage
' Update the weather page.
' The data from the sensors is taken direct from the class dataSampler
Sub UpdatePage	'ignore
	' Check the statusmessage
	' Something with sampling went wrong - stop sampling, update info on page and show messagebox
	If Not(DataSampler.SampleResult) Then
		ABMShared.labelSampleStatus.Text = $"${DataSampler.SampleLogMessage}"$
		page.Msgbox("MSGBOXUPDATEERROR", $"${DataSampler.SampleLogMessage}"$, "Sampling Error", "OK", True, ABM.MSGBOX_POS_CENTER_CENTER, "bluegrey")
	End If

	If DataSampler.SampleResult Then
		' REMOVE = Check if there is data
		' If DataSampler.SampleData.Size = 0 Then Return
		' Update the Gauges - the SampleData list last map entry is taken
		Dim m As Map = DataSampler.SampleData.Get(DataSampler.SampleData.Size - 1)
		customGaugeHumidity.GaugeValue = m.Get("humidity")
		customGaugeTemperature.GaugeValue = m.Get("temperature")
		customGaugeAirPressure.GaugeValue = m.Get("airpressure")

		' Update the charts
		LineChartHumidity.UpdateDataPoints(page, LineChartHumidity.ABMComp.ID, BuildJSONString(DataSampler.SampleData, "humidity"))
		LineChartTemperature.UpdateDataPoints(page, LineChartTemperature.ABMComp.ID, BuildJSONString(DataSampler.SampleData, "temperature"))
		LineChartAirPressure.UpdateDataPoints(page, LineChartAirPressure.ABMComp.ID, BuildJSONString(DataSampler.SampleData, "airpressure"))

		' Update the trend info in the footer with first - last timestamp, number of data points
		Dim mf As Map = DataSampler.SampleData.Get(0)
		Dim ml As Map = DataSampler.SampleData.Get(DataSampler.SampleData.Size - 1)
		'To use color enclose the string in {C:#0000FF}infostring{/C} for blue text color
		ABMShared.labelSampleStatus.Text = $"${mf.Get("timestamp")} - ${ml.Get("timestamp")} #${DataSampler.SampleData.Size}"$
	End If
	ABMShared.labelSampleStatus.Refresh

	' Refresh the page
	page.Refresh
End Sub

' Build the JSON string from the sampledata for a sensor, i.e. humidity. The JSON string is used by the CustomLineChart to update the chart.
' The sampledata format example:
' "timestamp":TimeStamp, "humidity":Humidity, "temperature":Temperature, "airpressure":AirPressure)
' Example: <code>
' BuildJSONString(SampleData, "humidity")
' Output: [ { "timestamp":"20:50", "value":55.4 },{ "timestamp":"20:50", "value":55.6 } ]
' </code>
Sub BuildJSONString(SampleData As List, Sensor As String) As String
	Dim ts As String
	Dim value As Double
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each m As Map In SampleData
		ts = m.Get("timestamp")
		value = m.Get($"${Sensor}"$)
		Dim s As String = $"{ "timestamp":"${ts}", "value":${value} },"$
		sb.Append(s)
	Next
	sb.Append("]")
	Return sb.tostring.Replace("},]", "}]")
End Sub
#End Region
